if ((typeof google.maps).toLowerCase() == 'undefined') google.load('maps', '2', {'language' : (typeof googlemapsAnywhereL10n != 'undefined' ? googlemapsAnywhereL10n.language : 'en')});
if ((typeof jQuery).toLowerCase() == 'undefined') google.load('jquery', '1.2');

google.setOnLoadCallback(function(){
  var gma_opt = jQuery.extend({
    markerTitle:'Move to the Google map.'
   ,cssPath:'div.map'
   ,language:'en'
   }, googlemapsAnywhereL10n);

  var markeropt = {title:gma_opt.markerTitle};

  jQuery(gma_opt.cssPath).each( function(){
    var map_link = jQuery(this).children('a:first');
    var map_url = map_link.attr('href');
    var map_type = G_NORMAL_MAP;
    var street_view_flag = false;

    var zoom = Number(map_url.replace(/^.*(\?|\&|\&amp;)z=([\d]+)[\&]?.*$/i,'$2'));
    zoom = ((zoom == NaN ? 0 : zoom) > 0 ? zoom : 14);

    switch (map_url.replace(/^.*(\?|\&|\&amp;)t=([^\&]+)[\&]?.*$/i,'$2').toUpperCase()) {
     case 'NORMAL':
     case 'G_NORMAL_MAP':
      map_type = G_NORMAL_MAP;
      break;
     case 'SATELLITE':
     case 'G_SATELLITE_MAP':
      map_type = G_SATELLITE_MAP;
      break;
     case 'HYBRID':
     case 'G_HYBRID_MAP':
      map_type = G_HYBRID_MAP;
      break;
     case 'PHYSICAL':
     case 'G_PHYSICAL_MAP':
      map_type = G_PHYSICAL_MAP;
      break;
     case 'STREETVIEW':
      street_view_flag = true;
      break;
    };

    var latlng = map_url.replace(/^.*(\?|\&|\&amp;)q=([^\&]+)[\&]?.*$/i,'$2').split(",");
    if (latlng.length >= 2) {
      var map, marker;
      var point = new google.maps.LatLng(Number(latlng[0]), Number(latlng[1]));
      if (point) {
        map_url = 'http://maps.google.co.jp/maps?hl=' + gma_opt.language + '&q=' + point.toUrlValue() + '&z=' + zoom;

        if (!street_view_flag) {
          map = new google.maps.Map2(this);
          map.addControl(new google.maps.SmallZoomControl());
          map.setCenter(point, zoom, map_type);

          marker = new google.maps.Marker(map.getCenter(), markeropt);
          map.addOverlay(marker);
          google.maps.Event.addListener(marker, 'click', function(){location.href = map_url;});

        } else {
          var pov = {
            yaw : (latlng.length >= 3 ? Number(latlng[2]) : 0)
           ,pitch: (latlng.length >= 4 ? Number(latlng[3]) : 5)
           ,zoom: (latlng.length >= 5 ? Number(latlng[3]) : 0)
          };
          map = new google.maps.StreetviewPanorama(this, {latlng:point, pov:pov});
        }
      }
    }
  });
});
